SoW-2020-0002: Trace Hit Counters: trigger error reporting integration
[lttng-tools.git] / tests / regression / tools / rotation / rotate_utils.sh
index 37ada94864338cccf4556b1c49eb644ddef65ef0..8ff93f91d87085be9c26c1bd10656c02891f9a20 100644 (file)
@@ -1,9 +1,39 @@
-function set_chunk_pattern ()
+#!/bin/bash
+#
+# Copyright (C) 2017 Julien Desfossez <jdesfossez@efficios.com>
+#
+# SPDX-License-Identifier: LGPL-2.1-only
+
+# Clean everything under directory but keep directory
+function clean_path ()
 {
-       # Need to call this function after $today has been set.
+       local path=$1
+       # Use -u from bash top prevent empty expansion of variable yielding a
+       # list of current directory from find.
+       set -u
+       find $path -mindepth 1 -maxdepth 1 -exec rm -rf '{}' \;
+       set +u
+}
+
+# The extglob shell option must be enabled to use the pattern generated by this
+# function (shopt -s extglob/ shopt -u extglob).
+# The pattern returned by this function is to validate the form:
+#    YYYYMMDDTHHMMSS[+-]HHMM-YYYYMMDDTHHMMSS[+-]HHMM
+#
+# Where YYYYMMDD is today or tomorrow. Tomorrow must be supported in case where
+# the chunks are generated close to midnight and one ends up the following day.
+function get_chunk_pattern ()
+{
+       local today=$1
+       tommorow=$(date +%Y%m%d -d "${today}+1days")
+       pattern_hour_min="[0-9][0-9][0-9][0-9]"
+       pattern_hour_min_sec="${pattern_hour_min}[0-9][0-9]"
 
+       base_pattern="@(${today}|${tommorow})T${pattern_hour_min_sec}[+-]${pattern_hour_min}"
+
+       # Return the pattern
        # YYYYMMDDTHHMMSS[+-]HHMM-YYYYMMDDTHHMMSS[+-]HHMM
-       export chunk_pattern="${today}T[0-9][0-9][0-9][0-9][0-9][0-9][+-][0-9][0-9][0-9][0-9]-${today}T[0-9][0-9][0-9][0-9][0-9][0-9][+-][0-9][0-9][0-9][0-9]"
+       echo "${base_pattern}-${base_pattern}"
 }
 
 function validate_test_chunks ()
@@ -14,63 +44,40 @@ function validate_test_chunks ()
        domain=$4
        per_pid=$5
 
-       set_chunk_pattern
+       local path=
+       local chunk_pattern=$(get_chunk_pattern ${today})
+
+       # Enable extglob for the use of chunk_pattern
+       shopt -s extglob
+
+       # Validate that only 2 chunks are present
+       nb_chunk=$(ls -A $local_path | wc -l)
+       test $nb_chunk -eq 2
+       ok $? "${local_path} contains 2 chunks only"
 
-       # Check if the 3 chunk folders exist and they contain a ${app_path}/metadata file.
-       ls $local_path/${chunk_pattern}-1/${app_path}/metadata >/dev/null
-       ok $? "Chunk 1 exists"
-       ls $local_path/${chunk_pattern}-2/${app_path}/metadata >/dev/null
-       ok $? "Chunk 2 exists"
-       ls $local_path/${chunk_pattern}-3/${domain} >/dev/null
-       ok $? "Chunk 3 exists"
+       # Check if the first and second chunk folders exist and they contain a ${app_path}/metadata file.
+       for chunk in $(seq 0 1); do
+               path=$(ls $local_path/${chunk_pattern}-${chunk}/${app_path}/metadata)
+               ok $? "Chunk ${chunk} exists based on path $path"
+       done
 
        # Make sure we don't have anything else in the first 2 chunk directories
        # besides the kernel folder.
-       nr_stale=$(\ls $local_path/${chunk_pattern}-1 | grep -v $domain | wc -l)
-       ok $nr_stale "No stale folders in chunk 1 directory"
-       nr_stale=$(\ls $local_path/${chunk_pattern}-2 | grep -v $domain | wc -l)
-       ok $nr_stale "No stale folders in chunk 2 directory"
+       for chunk in $(seq 0 1); do
+               nr_stale=$(ls -A $local_path/${chunk_pattern}-${chunk} | grep -v $domain | wc -l)
+               ok $nr_stale "No stale folders in chunk ${chunk} directory"
+       done
 
-       # We expect a session of 30 events
+       # We expect a complete session of 30 events
        validate_trace_count $EVENT_NAME $local_path 30
 
        # Chunk 1: 10 events
-       validate_trace_count $EVENT_NAME $local_path/${chunk_pattern}-1 10
-       if [ $? -eq 0 ]; then
-               # Only delete if successful
-               rm -rf $local_path/${chunk_pattern}-1
-       fi
+       validate_trace_count $EVENT_NAME $local_path/${chunk_pattern}-0 10
 
        # Chunk 2: 20 events
-       validate_trace_count $EVENT_NAME $local_path/${chunk_pattern}-2 20
-       if [ $? -eq 0 ]; then
-               # Only delete if successful
-               rm -rf $local_path/${chunk_pattern}-2
-       fi
+       validate_trace_count $EVENT_NAME $local_path/${chunk_pattern}-1 20
 
-       # Chunk 3: 0 event
-       # Do not check in per-pid, because the folder is really empty, no metadata
-       # or stream files.
-       if test $per_pid = 1; then
-               rm -rf $local_path/${chunk_pattern}-3
-       else
-               validate_trace_empty $local_path/${chunk_pattern}-3
-               if [ $? -eq 0 ]; then
-                       # Only delete if successful
-                       rm -rf $local_path/${chunk_pattern}-3
-               fi
-       fi
-
-       # The session folder after all chunks have been removed is empty
-       test -z "$(\ls -A $local_path)"
-       empty=$?
-       ok $empty "Trace folder is now empty"
-       if [ $empty -eq 0 ]; then
-       # Only delete if successful
-               rm -rf $local_path/
-       else
-               find $local_path
-       fi
+       shopt -u extglob
 }
 
 function rotate_timer_test ()
@@ -83,6 +90,11 @@ function rotate_timer_test ()
        nr_iter=0
        expected_chunks=3
 
+       # Wait for the "archives" folder to appear after the first rotation
+       until [ -d $local_path ]; do
+           sleep 1
+       done
+
        # Wait for $expected_chunks to be generated, timeout after
        # 3 * $expected_chunks * 0.5s.
        # On a laptop with an empty session, a local rotation takes about 200ms,
@@ -96,34 +108,33 @@ function rotate_timer_test ()
                sleep 1
        done
        test $nr -ge $expected_chunks
-       ok $? "Generated $nr chunks in $(($nr_iter))s"
+       ok $? "Generated at least $nr chunks in $(($nr_iter))s"
        stop_lttng_tracing_ok $SESSION_NAME
        destroy_lttng_session_ok $SESSION_NAME
 
-       now=$(date +%Y%m%d)
-       test $today = $now
-       ok $? "Date did not change during the test"
-
-       # Make sure the 10 first chunks are valid empty traces
        i=1
-       set_chunk_pattern
+       local chunk_pattern=$(get_chunk_pattern ${today})
+
+       # Enable extglob for the use of chunk_pattern
+       shopt -s extglob
 
        # In a per-pid setup, only the first chunk is a valid trace, the other
        # chunks should be empty folders
        if test $per_pid = 1; then
-               validate_trace_empty $local_path/${chunk_pattern}-1
-               nr=$(ls $local_path/${chunk_pattern}-2/ust | wc -l)
-               test $nr = 0
+               validate_trace_empty $local_path/${chunk_pattern}-0
+               nr=$(find $local_path/${chunk_pattern}-1/ | wc -l)
+               # contains self and may contain ust/ subdir (local) or not (remote).
+               test $nr -le 2
                ok $? "Chunk 2 is empty"
-               nr=$(ls $local_path/${chunk_pattern}-3/ust | wc -l)
-               test $nr = 0
+               nr=$(find $local_path/${chunk_pattern}-2/ | wc -l)
+               # contains self and may contain ust/ subdir (local) or not (remote).
+               test $nr -le 2
                ok $? "Chunk 3 is empty"
        else
                while [ $i -le $expected_chunks ]; do
                        validate_trace_empty $local_path/${chunk_pattern}-$i
                        i=$(($i+1))
-       done
-fi
-
-       rm -rf $local_path
+               done
+       fi
+       shopt -u extglob
 }
This page took 0.026367 seconds and 5 git commands to generate.